import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

//-------------------------------------------------------------
public class Dict extends JFrame {

public class StringA extends ArrayList<String> {}
public class StringV extends Vector<String> {}

static Dict mf;

JButton       sbar;
JList<String> lbox;
JScrollPane   splb, spta;
JTextArea     txta;

Font          lbf, taf, uif;
int           maxx, maxy, winx, winy;
int           lbfs, lbp, tafs, uifs, wxp, wyp;
String        stxt;
StringA       wrds;

static final int    LBFSIZ = 32;
static final int    TAFSIZ = 16;
static final int    UIFSIZ = 64;

static final String LBFSLIT = "LBFS";
static final String LBPLIT  = "LBP";
static final String TAFSLIT = "TAFS";
static final String UIFSLIT = "UIFS";
static final String WXPLIT  = "WXP";
static final String WYPLIT  = "WYP";

//-------------------------------------
class ALookup implements ActionListener {
public void actionPerformed(ActionEvent lae) {
int     idx;
String  lwrd;
  lwrd = JOptionPane.showInputDialog(mf, "Lookup");
  lwrd = lwrd.toUpperCase();
  lbox.setSelectedValue(lwrd, true);
}}

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent qae) {
   System.exit(0);
}}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent cbae) {
  PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
int   kc;
  kc = ke.getKeyCode();
  if (kc == KeyEvent.VK_F1) PopupMain();
}}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
Dimension dim;
Insets    is;
int       sbh;
  sbh = sbar.getHeight();
  winx = getWidth();
  winy = getHeight();
  is = mf.getInsets();
  winx -= (is.left+is.right);
  winy -= (is.top+is.bottom);
  dim = new Dimension((winx*lbp)/100, winy-sbh);
  splb.setPreferredSize(dim);
}}

//-------------------------------------
class CBSelection implements ListSelectionListener {
public void valueChanged(ListSelectionEvent e) {
int     idx;
String  def;
  idx = lbox.getSelectedIndex();
  if (idx==-1) return;
  if (idx>=wrds.size()) return;
  def = GetDefinition(idx);
  txta.setText(def);
  txta.setCaretPosition(0);
  def = wrds.get(idx);
  sbar.setText(def);
}}

//-------------------------------------
public Dict() {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
}

//-------------------------------------
void DspMsg(String msg) {
JScrollPane sp;
JTextArea   ta;
  ta = new JTextArea(10,30);
  ta.setFont(uif);
  ta.setEditable(false);
  ta.setLineWrap(true);
  ta.setWrapStyleWord(true);
  ta.setText(msg);
  sp = new JScrollPane(ta);
  sp.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
  JOptionPane.showMessageDialog(mf, sp);
}

//-------------------------------------
String GetDefinition(int idx) {
BufferedReader    br;
InputStream       is;
InputStreamReader isr;
int               i;
String            line, rv;
  rv = "";
  is = mf.getClass().getResourceAsStream("/ed.txt");
  try {
    isr = new InputStreamReader(is);
    br = new BufferedReader(isr);
    for (i=0; i<idx; i++) line = br.readLine();
    rv = br.readLine();
  } catch(Exception e) { DspMsg("Failed Read Help"); }
  return(rv);
}

//-------------------------------------
public void Initlz() {
  InitlzVars();
  ReadIniFile();
  InitlzUI();
  LayoutUI();
}

//-------------------------------------
void InitlzUI() {
  winx = (wxp*maxx)/100;
  winy = (wyp*maxy)/100;
  InitlzUIFonts();
  InitlzUIListBox();
  InitlzUIStatusBar();
  InitlzUITextArea();
  InitlzUIResources();
}

//-------------------------------------
void InitlzUIFonts() {
  lbf = new Font(Font.SERIF, Font.BOLD, lbfs);
  taf = new Font(Font.SERIF, Font.BOLD, tafs);
  uif = new Font(Font.SERIF, Font.BOLD, uifs);
}

//-------------------------------------
void InitlzUIListBox() {
Dimension   dim;
JScrollBar  jsb;
  lbox = new JList<String>();
  lbox.addKeyListener(new CBKey());
  lbox.setFont(lbf);
  lbox.setBackground(new Color(0xFFFFFF));
  lbox.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  lbox.addListSelectionListener(new CBSelection());
  splb = new JScrollPane(lbox);
  splb.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
  splb.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
  jsb = splb.getVerticalScrollBar();
  dim = jsb.getPreferredSize();
  dim.width *=4;
  jsb.setPreferredSize(dim);
}

//-------------------------------------
void InitlzUIResources() {
Image       iimg;
InputStream is;
Toolkit     tk;
URL         iurl;
  tk = Toolkit.getDefaultToolkit();
  iurl = mf.getClass().getResource("/Dict.jpg");
  iimg = tk.createImage(iurl);
  setIconImage(iimg);
  is = mf.getClass().getResourceAsStream("/ew.txt");
  ReadWords(is);
}

//-------------------------------------
void InitlzUIStatusBar() {
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.addKeyListener(new CBKey());
}

//-------------------------------------
void InitlzUITextArea() {
Dimension   dim;
JScrollBar  jsb;
  txta = new JTextArea();
  txta.addKeyListener(new CBKey());
  txta.setFont(taf);
  txta.setBackground(new Color(0xC0FFC0));
  txta.setLineWrap(true);
  txta.setWrapStyleWord(true);
  spta = new JScrollPane(txta);
  spta.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
  spta.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
  jsb = spta.getVerticalScrollBar();
  dim = jsb.getPreferredSize();
  dim.width *=4;
  jsb.setPreferredSize(dim);
}

//-------------------------------------
void InitlzVars() {
  lbfs = LBFSIZ;
  tafs = TAFSIZ;
  uifs = UIFSIZ;
  wxp = 80;
  wyp = 80;
  lbp = 25;
  stxt = "Click Here";
  wrds = new StringA();
}

//-------------------------------------
void LayoutUI() {
  mf.addKeyListener(new CBKey());
  mf.addComponentListener(new CBResize());
  mf.setLocation((maxx-winx)/2, 0);
  mf.setSize(winx, winy);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(splb, BorderLayout.WEST);
  mf.getContentPane().add(spta, BorderLayout.CENTER);
  mf.setTitle("Dictionary");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
}

//-------------------------------------
void LoadListBox() {
int       i, nwrd;
StringV   lins;
String    lin, wrd;
  nwrd = wrds.size();
  lins = new StringV();
  for (i=0; i<nwrd; i++) {
    lin = wrds.get(i);
    lins.add(lin);
  }
  lbox.setListData(lins);
  lbox.setSelectedIndex(0);
}

//-------------------------------------
public static void main(String[] args) {
  mf = new Dict();
  mf.Initlz();
}

//-------------------------------------
void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Lookup");
  mi.setMnemonic('L');
  mi.addActionListener(new ALookup());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}

//-------------------------------------
void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"Dict.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(LBFSLIT)==0) lbfs = Integer.parseInt(val);
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(TAFSLIT)==0) tafs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
        if (nam.compareTo(LBPLIT)==0) lbp = Integer.parseInt(val);
      }
    }
  } catch (IOException x) { System.err.format("IOException: %s%n", x); }
}

//-------------------------------------
void ReadWords(InputStream is) {
BufferedReader    br;
InputStreamReader isr;
String            line;
  try {
    isr = new InputStreamReader(is);
    br = new BufferedReader(isr);
    do {
      line = br.readLine();
      if (line != null) wrds.add(line);
    } while (line != null);         
  } catch(Exception e) { DspMsg("Failed ReadWords"); }
  LoadListBox();
}

//+++++++++++++++++++++++++++++++++++++
}
